
/* version.c */

/* backspac.c */
integer f_back(alist *a);

/* close.c */
integer f_clos(cllist *a);
void f_exit(void);
int flush_(void);

/* dfe.c */
integer s_rdfe(cilist *a);
integer s_wdfe(cilist *a);
integer e_rdfe(void);
integer e_wdfe(void);
int c_dfe(cilist *a);
int y_rsk(void);
int y_getc(void);
int y_putc(int c);
int y_rev(void);
int y_err(void);
int y_newrec(void);

/* dolio.c */
integer do_lio(ftnint *type, ftnint *number, char *ptr, ftnlen len);

/* due.c */
integer s_rdue(cilist *a);
integer s_wdue(cilist *a);
int c_due(cilist *a);
integer e_rdue(void);
integer e_wdue(void);

/* err.c */
int fatal(int n, char *s);
int f_init(void);
int canseek(FILE *f);
int nowreading(unit *x);
int nowwriting(unit *x);

/* fmt.c */
int pars_f(char *s);
char *f_s(char *s, int curloc);
char *f_list(char *s);
char *i_tem(char *s);
int ne_d(char *s, char **p);
int e_d(char *s, char **p);
int op_gen(int a, int b, int c, int d);
char *gt_num(char *s, int *n);
integer do_fio(ftnint *number, char *ptr, ftnlen len);
int en_fio(void);
int fmt_bg(void);
int type_f(int n);
char *ap_end(char *s);

/* fmtlib.c */
char *icvt(long value, int *ndigit, int *sign, int base);

/* iio.c */
int z_getc(void);
int z_putc(int c);
int z_rnew(void);
integer s_rsfi(icilist *a);
integer s_wsfi(icilist *a);
int c_si(icilist *a);
int z_wnew(void);
integer e_rsfi(void);
integer e_wsfi(void);
int y_ierr(void);

/* ilnw.c */
int c_liw(icilist *a);
int s_wsni(icilist *a);
integer s_wsli(icilist *a);
integer e_wsli(void);

/* inquire.c */
integer f_inqu(inlist *a);

/* lread.c */
int t_getc(void);
integer e_rsle(void);
int l_read(ftnint *number, char *ptr, ftnlen len, ftnint type);
int l_R(int poststar);
int l_C(void);
int l_L(void);
int l_CHAR(void);
integer s_rsle(cilist *a);
int c_le(cilist *a);

/* lwrite.c */
int t_putc(int c);
int lwrt_I(ftnint n);
int lwrt_L(ftnint n, ftnlen len);
int lwrt_A(char *p, ftnlen len);
int lwrt_F(double n);
int lwrt_C(double a, double b);
int l_write(ftnint *number, char *ptr, ftnlen len, ftnint type);

/* rdfmt.c */
int rd_ed(struct syl *p, char *ptr, ftnlen len);
int rd_ned(struct syl *p);
int rd_I(Uint *n, int w, ftnlen len, int base);
int rd_L(ftnint *n, int w);
int rd_F(ufloat *p, int w, int d, ftnlen len);
int rd_A(char *p, ftnlen len);
int rd_AW(char *p, int w, ftnlen len);
int rd_H(int n, char *s);
int rd_POS(char *s);

/* rewind.c */
integer f_rew(alist *a);

/* rsfe.c */
integer s_rsfe(cilist *a);
int xrd_SL(void);
int x_getc(void);
int x_endp(void);
int x_rev(void);

/* rsli.c */
int i_getc(void);
int i_ungetc(int ch);
integer s_rsli(icilist *a);
integer e_rsli(void);
int s_rsni(icilist *a);

/* rsne.c */
hashtab *mk_hashtab(Namelist *nl);
int x_rsne(cilist *a);
integer s_rsne(cilist *a);

/* sfe.c */
integer e_rsfe(void);
int c_sfe(cilist *a);
integer e_wsfe(void);

/* sue.c */
integer s_rsue(cilist *a);
integer s_wsue(cilist *a);
int c_sue(cilist *a);
integer e_wsue(void);
integer e_rsue(void);

/* typesize.c */

/* uio.c */
int do_us(ftnint *number, char *ptr, ftnlen len);
integer do_uio(ftnint *number, char *ptr, ftnlen len);
int do_ud(ftnint *number, char *ptr, ftnlen len);

/* util.c */
int g_char(char *a, ftnlen alen, char *b);
int b_char(char *a, char *b, ftnlen blen);
long inode(char *a, int *dev);
int mvgbt(int n, int len, char *a, char *b);

/* wref.c */
int wrt_E(ufloat *p, int w, int d, int e, ftnlen len);
int wrt_F(ufloat *p, int w, int d, ftnlen len);

/* wrtfmt.c */
int mv_cur(void);
int w_ed(struct syl *p, char *ptr, ftnlen len);
int w_ned(struct syl *p);
int wrt_I(Uint *n, int w, ftnlen len, int base);
int wrt_IM(Uint *n, int w, int m, ftnlen len);
int wrt_AP(char *s);
int wrt_H(int a, char *s);
int wrt_L(Uint *n, int len, ftnlen sz);
int wrt_A(char *p, ftnlen len);
int wrt_AW(char *p, int w, ftnlen len);
int wrt_G(ufloat *p, int w, int d, int e, ftnlen len);

/* wsfe.c */
integer s_wsfe(cilist *a);
int x_putc(int c);
int pr_put(int c);
int x_wSL(void);
int xw_end(void);
int xw_rev(void);

/* wsle.c */
integer s_wsle(cilist *a);
integer e_wsle(void);

/* wsne.c */
integer s_wsne(cilist *a);

/* xwsne.c */
int x_wsne(cilist *a);

/* open.c */
integer f_open(olist *a);
int fk_open(int seq, int fmt, ftnint n);
int isdev(char *s);

/* endfile.c */
integer f_end(alist *a);
int t_runc(alist *a);
